image:
  name: quay.io/singularity/singularity:v3.8.1
  entrypoint: ["/bin/sh", "-c"]

before_script:
  - singularity --version
  - pwd; ls -la

stages:
  - build
  - deploy

build:
  variables:
    SINGULARITYENV_CI_COMMIT_SHORT_SHA: ${CI_COMMIT_SHORT_SHA}
    SINGULARITYENV_GITHUB_PAT: ${GITHUB_PAT}
  rules:
    - changes:
      - Singularity.def
  stage: build
  script:
    - singularity build ${CI_PROJECT_NAME}.sif Singularity.def

  tags:
    - oit-shared
  artifacts:
    paths:
      - ${CI_PROJECT_NAME}.sif
    untracked: false
    expire_in: 48 hours

deploy:
  tags:
    - oit-shared
  rules:
    - if: '$CI_COMMIT_TAG != null'
  variables:
    SINGULARITY_DOCKER_USERNAME: ${CI_REGISTRY_USER}
    SINGULARITY_DOCKER_PASSWORD: ${CI_REGISTRY_PASSWORD}
  stage: deploy
  script:
    - singularity push ${CI_PROJECT_NAME}.sif "oras://${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}"
